package bloques;

import java.io.*;
import java.lang.ClassLoader;

/* Permite abrir la clase Bloque generada en la versin 1.4 de DependTool */
public class ObjectInputStream14
    extends ObjectInputStream {
  public ObjectInputStream14(InputStream in) throws IOException {
    super(in);
  }

  /* Basado en http://forums.sun.com/thread.jspa?threadID=518416 */
  protected ObjectStreamClass readClassDescriptor() throws IOException,
      ClassNotFoundException {

    // Inicializar el descriptor de stream
    ObjectStreamClass resultClassDescriptor = super.readClassDescriptor();

    // Clase en la JVM que representa este stream que se est leyendo
    Class localClass = Class.forName(resultClassDescriptor.getName());
    if (localClass == null) {
      return resultClassDescriptor;
    }

    ObjectStreamClass localClassDescriptor = ObjectStreamClass.lookup(
        localClass);
    if (localClassDescriptor != null) { // slo si la clase implementa serializable
      final long localSUID = localClassDescriptor.getSerialVersionUID();
      final long streamSUID = resultClassDescriptor.getSerialVersionUID();
      long suidBloque = Bloque.serialVersionUID;
      long suidBloqueVersion14 = 9122061219071415581L;

      // Si se lee un objecto de la versin 1.4 de la clase bloque y se est
      // con la clase bloque en su versin actual (que coincide con la 1.3)
      // realizar una adaptacin a la versin actual
      if ( (streamSUID == suidBloqueVersion14) && (localSUID == suidBloque)) {
        return localClassDescriptor;
      }
    }
    return resultClassDescriptor;
  }
}
