package interfaz;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import interfaz.deshacer.*;

/**
 * <p>Title: DialogoCambiarNombre.java</p>
 * <p>Description: Define los dilogos de cambio de nombre</p>
 * @author Diego Daz Garca
 * @version 1.0
 */

public class DialogoCambiarNombre extends JDialog implements ActionListener{
  JPanel panel1 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JTextField jTextField1 = new JTextField();
  JButton jButton2 = new JButton();
  JButton jButton1 = new JButton();
  FiguraBloque figuraaModificar;

  /**Constructor
   * @param frame Ventana principal de la aplicacin
   * @param title Ttulo del dilogo
   * @param modal Representa el carcter modal o no de la ventana*/
  public DialogoCambiarNombre(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  /**Constructor
   * @param figuraaModificar_ FiguraBloque al que se le a cambiar el nombre*/
  public DialogoCambiarNombre(Frame padre, FiguraBloque figuraaModificar_) {
    this(padre, "Cambiar Nombre", false);
    figuraaModificar = figuraaModificar_;
    jTextField1.setText(figuraaModificar.obtenerNombre());
    jTextField1.setSelectionStart(0);
    jTextField1.setSelectionEnd(jTextField1.getText().length());
  }

  /**Inicializa el dilogo cambiar nombre
   * @throws Exception */
  private void jbInit() throws Exception {
    panel1.setLayout(null);
    this.getContentPane().setLayout(null);
    panel1.setBounds(new Rectangle(10, 10, 266, 108));
    jLabel1.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel1.setRequestFocusEnabled(true);
    jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel1.setText("Introduzca el nuevo nombre del bloque");
    jLabel1.setBounds(new Rectangle(9, 5, 240, 27));
    jTextField1.setFont(new java.awt.Font("Dialog", 0, 12));
    jTextField1.setAlignmentX((float) 0.5);
    jTextField1.setText("");
    jTextField1.setHorizontalAlignment(SwingConstants.LEFT);
    jTextField1.setBounds(new Rectangle(11, 38, 236, 20));
    jButton2.setText("Cancelar");
    jButton2.addActionListener(this);
    jButton2.setBounds(new Rectangle(131, 67, 84, 23));
    jButton2.setFont(new java.awt.Font("Dialog", 0, 12));
    jButton1.setBounds(new Rectangle(40, 67, 84, 23));
    jButton1.setFont(new java.awt.Font("Dialog", 0, 12));
    jButton1.setText("Aceptar");
    jButton1.addActionListener(this);
    getContentPane().add(panel1, null);
    panel1.add(jTextField1, null);
    panel1.add(jButton1, null);
    panel1.add(jButton2, null);
    panel1.add(jLabel1, null);
    getRootPane().setDefaultButton(jButton1);
    jButton1.setDefaultCapable(true);
  }
  /**Permite procesar el evento de cerrar ventana
   * @param e Evento de cerrar ventana*/
    protected void processWindowEvent(WindowEvent e) {
      if (e.getID() == WindowEvent.WINDOW_CLOSING) {
        cancel();
      }
      super.processWindowEvent(e);
    }
    //Close the dialog
    void cancel() {
      dispose();
    }
    //Close the dialog on a button event
    public void actionPerformed(ActionEvent e) {
      if (e.getSource() == jButton2) {
        cancel();
      }
      if (e.getSource() == jButton1) {
        if (figuraaModificar.cambiarNombre(jTextField1.getText()))
           cancel();
        else {
          JOptionPane.showMessageDialog(null,
          "Elija otro nombre, ya existe otro diagrama con el nombre "
          +jTextField1.getText(),
          "Nombre duplicado",JOptionPane.ERROR_MESSAGE);
        }
      }
 }
}
