package interfaz;

import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.text.DecimalFormat;
import java.text.NumberFormat;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.SwingConstants;
import javax.swing.text.NumberFormatter;
import java.awt.event.KeyEvent;

/**
 * <p>Title: ObtenerResultados.java</p>
 * <p>Description: Clase para las ventanas previas a los resultados, en las
 * que se introducir el valor de t</p>
 * @author Diego Daz Garca
 * @version 1.0
 */

public class PedirTiempoFiabilidad
    extends JDialog
    implements ActionListener, KeyListener {
  JFormattedTextField campoTiempo;
  JButton botonAceptar = new JButton();
  JButton botonCancelar = new JButton();
  Double tiempo;
  boolean seCancela = false;

  public PedirTiempoFiabilidad(FramePrincipal ventanaPrincipal,
                               Double tiempoPorDefecto) {
    super(ventanaPrincipal, "Obtener resultados", false);
    tiempo = tiempoPorDefecto;
    try {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
}

  private void jbInit() throws Exception {
    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    // Formato para los valores de los campos
    NumberFormat formatoTiempo;

    // se prepara el formato que van a tener los campos
    formatoTiempo = new DecimalFormat("#0.0#############");
    NumberFormatter mascaraDouble = new NumberFormatter(formatoTiempo);
    mascaraDouble.setOverwriteMode(false);
    mascaraDouble.setAllowsInvalid(false);

    campoTiempo = new JFormattedTextField(mascaraDouble);
    jLabel1.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel1.setText("Introduzca el valor del tiempo para el cual");
    jLabel1.setBounds(new Rectangle(16, 5, 243, 27));
    this.getContentPane().setLayout(null);
    jLabel2.setBounds(new Rectangle(16, 27, 243, 27));
    jLabel2.setText("desea calcular la fiabilidad del sistema");
    jLabel2.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel2.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel2.setFont(new java.awt.Font("Dialog", 1, 12));
    campoTiempo.setFont(new java.awt.Font("Dialog", 0, 12));
    campoTiempo.setHorizontalAlignment(SwingConstants.RIGHT);
    campoTiempo.setBounds(new Rectangle(24, 55, 227, 20));
    botonAceptar.setBounds(new Rectangle(52, 84, 84, 23));
    botonAceptar.setFont(new java.awt.Font("Dialog", 0, 12));
    botonAceptar.setSelected(true);
    botonAceptar.setText("Aceptar");
    botonAceptar.addActionListener(this);
    botonCancelar.setText("Cancelar");
    botonCancelar.addActionListener(this);
    botonCancelar.setBounds(new Rectangle(143, 84, 84, 23));
    botonCancelar.setFont(new java.awt.Font("Dialog", 0, 12));
    this.setResizable(false);
    this.getContentPane().add(jLabel1, null);
    this.getContentPane().add(jLabel2, null);
    this.getContentPane().add(campoTiempo, null);
    this.getContentPane().add(botonCancelar, null);
    this.getContentPane().add(botonAceptar, null);

    // Inicializo el campo Tiempo con el valor dispuesto en Opciones
    campoTiempo.setValue(tiempo);

    // Para escuchar el keyrelease
    campoTiempo.addKeyListener(this);
  }


  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cerrarVentana();
    }
     super.processWindowEvent(e);
  }

  //Close the dialog
  void cerrarVentana() {
    dispose();
  }

  //Close the dialog on a button event
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == botonCancelar) {
      seCancela = true;
    }
    if (e.getSource() == botonAceptar) {
      tiempo = Double.valueOf (campoTiempo.getValue().toString());
    }
    cerrarVentana();
  }

  public Double obtenerTiempo() { return tiempo; }
  public boolean huboCancel() { return seCancela; }

  public void keyTyped(KeyEvent e) {}
  public void keyPressed(KeyEvent e) {}
  public void keyReleased(KeyEvent e)  {
    int key = e.getKeyCode();

    if (key == KeyEvent.VK_ENTER) {
      tiempo = Double.valueOf(campoTiempo.getValue().toString());

      // Mismo comportamiento que pulsando aceptar
      cerrarVentana();
    }
 }

}
