package interfaz;

import interfaz.deshacer.PreferenciasAceptarEdit;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.text.DecimalFormat;
import java.text.NumberFormat;

import javax.swing.AbstractAction;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTabbedPane;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.text.NumberFormatter;
import javax.swing.undo.UndoableEdit;

/**
 * <p>Title: Preferencias.java</p>
 * <p>Description: Clase para las preferencias de la aplicacin</p>
 * @author Diego Daz Garca
 * @version 1.0
 */

public class Preferencias
    extends JDialog
    implements ActionListener {
  private String[] tamanios = {
      "Pequeo", "Mediano", "Grande", "Muy Grande"
  };

  private int[] tamanioFuentes = {
      10, 12, 14, 16
  };

  private double[] multiplicadores = {
      1, 1.5, 2, 2.5
  };

  private int[] tamaniosReales = {
      1, 2, 3, 4
  };

  JTabbedPane jTabbedPane1 = new JTabbedPane();
  JPanel panelFuente = new JPanel();
  JLabel colorFuenteLabel = new JLabel();
  JLabel tamanioFuenteLabel = new JLabel();
  JColorChooser elegirColorFuente = new JColorChooser();
  JPanel panelLineas = new JPanel();
  JLabel colorLineasLabel = new JLabel();
  JLabel anchoLineasLabel = new JLabel();
  JColorChooser elegirColorLineas = new JColorChooser();
  JLabel tamanioBloquesLabel = new JLabel();
  JColorChooser elegirColorBloques = new JColorChooser();
  JLabel colorBloquesLabel = new JLabel();
  JPanel panelBloques = new JPanel();
  JColorChooser elegirColorFondo = new JColorChooser();
  JLabel colorFondoLabel = new JLabel();
  JLabel lookLabel = new JLabel();
  JPanel panelLookFeel = new JPanel();
  JComboBox comboLook = new JComboBox();
  JButton cancelButton = new JButton();
  JButton acceptButton = new JButton();
  String actualLook = UIManager.getLookAndFeel().getName();
  UIManager.LookAndFeelInfo[] looks = UIManager.getInstalledLookAndFeels();
  FramePrincipal framePadre;
  JComboBox comboTamanioFuente = new JComboBox();
  JComboBox comboAnchoLineas = new JComboBox();
  JComboBox comboTamanioBloques = new JComboBox();
  Diagrama diagrama;
  Preferencias preferencias;
  JPanel panelVisualizacion = new JPanel();
  JPanel jPanel1 = new JPanel();
  TitledBorder titledBorder1;
  JRadioButton botonLambda = new JRadioButton();
  JRadioButton botonMttf = new JRadioButton();
  JRadioButton botonMtbf = new JRadioButton();
  JRadioButton botonMu = new JRadioButton();
  JPanel jPanel2 = new JPanel();
  JRadioButton botonMttr = new JRadioButton();
  Border border1;
  TitledBorder titledBorder2;
  JLabel jLabel5 = new JLabel();
  JFormattedTextField campoDecimalesPantalla;
  JFormattedTextField campoDecimalesResultado;
  JLabel jLabel9 = new JLabel();
  // Formato para los valores de los campos
  private NumberFormat formatoNumeroDecimales;
  private ButtonGroup botonesVisualizarF = new ButtonGroup();
  private ButtonGroup botonesVisualizarR = new ButtonGroup();

  public Preferencias(FramePrincipal frame, Diagrama diagrama) {
    super(frame, "Preferencias", false);
    try {
      framePadre = frame;
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
    this.diagrama = diagrama;
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancelar();
    }
    super.processWindowEvent(e);
  }

  //Close the dialog
  void cancelar() {
    dispose();
  }

  private void jbInit() throws Exception {
    jTabbedPane1.setBorder(null);
    panelLineas.setBorder(null);
    panelFuente.setBorder(null);
    panelBloques.setBorder(null);
    panelLookFeel.setBorder(null);
    botonesVisualizarF.add(botonLambda);
    botonesVisualizarF.add(botonMttf);
    botonesVisualizarF.add(botonMtbf);

    botonesVisualizarR.add(botonMu);
    botonesVisualizarR.add(botonMttr);

    // se prepara el formato que van a tener los campos
    formatoNumeroDecimales = new DecimalFormat("#");
    NumberFormatter mascaraEntero = new NumberFormatter(formatoNumeroDecimales);
    mascaraEntero.setOverwriteMode(false);
    mascaraEntero.setAllowsInvalid(false);

    campoDecimalesPantalla = new JFormattedTextField(mascaraEntero);
    campoDecimalesResultado = new JFormattedTextField(mascaraEntero);

    preferencias = this;
    titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.
        white, new Color(165, 163, 151)), "Visualizar reparabilidad");
    border1 = BorderFactory.createEtchedBorder(Color.white,
                                               new Color(165, 163, 151));
    titledBorder2 = new TitledBorder(border1, "Visualizar fiabilidad");
    this.getContentPane().setLayout(null);
    jTabbedPane1.setTabPlacement(JTabbedPane.TOP);
    jTabbedPane1.setBackground(Color.lightGray);
    jTabbedPane1.setEnabled(true);
    jTabbedPane1.setFont(new java.awt.Font("MS Sans Serif", 0, 11));
    jTabbedPane1.setForeground(Color.black);
    jTabbedPane1.setAlignmentX( (float) 0.5);
    jTabbedPane1.setAlignmentY( (float) 0.5);
    jTabbedPane1.setDebugGraphicsOptions(0);
    jTabbedPane1.setDoubleBuffered(false);
    jTabbedPane1.setMaximumSize(new Dimension(32767, 32767));
    jTabbedPane1.setOpaque(false);
    jTabbedPane1.setPreferredSize(new Dimension(9, 9));
    jTabbedPane1.setRequestFocusEnabled(true);
    jTabbedPane1.setBounds(new Rectangle(3, 8, 457, 373));
    jTabbedPane1.setSelectedIndex( -1);
    panelFuente.setLayout(null);
    colorFuenteLabel.setFont(new java.awt.Font("Dialog", 0, 12));
    colorFuenteLabel.setText("Color de fuente");
    colorFuenteLabel.setBounds(new Rectangle(8, 45, 98, 19));
    tamanioFuenteLabel.setFont(new java.awt.Font("Dialog", 0, 12));
    tamanioFuenteLabel.setText("Tamao de fuente");
    tamanioFuenteLabel.setVerticalTextPosition(SwingConstants.CENTER);
    tamanioFuenteLabel.setBounds(new Rectangle(8, 17, 136, 19));
    elegirColorFuente.setBounds(new Rectangle(8, 74, 433, 253));
    panelLineas.setLayout(null);
    colorLineasLabel.setFont(new java.awt.Font("Dialog", 0, 12));
    colorLineasLabel.setText("Color de lneas");
    colorLineasLabel.setBounds(new Rectangle(8, 45, 98, 19));
    anchoLineasLabel.setFont(new java.awt.Font("Dialog", 0, 12));
    anchoLineasLabel.setText("Ancho de lneas");
    anchoLineasLabel.setVerticalTextPosition(SwingConstants.CENTER);
    anchoLineasLabel.setBounds(new Rectangle(8, 17, 136, 19));
    elegirColorLineas.setBounds(new Rectangle(8, 74, 433, 253));
    tamanioBloquesLabel.setBounds(new Rectangle(8, 17, 136, 19));
    tamanioBloquesLabel.setVerticalTextPosition(SwingConstants.CENTER);
    tamanioBloquesLabel.setText("Tamao de Bloques");
    tamanioBloquesLabel.setFont(new java.awt.Font("Dialog", 0, 12));
    elegirColorBloques.setBounds(new Rectangle(8, 74, 433, 253));
    colorBloquesLabel.setBounds(new Rectangle(8, 45, 98, 19));
    colorBloquesLabel.setText("Color de bloques");
    colorBloquesLabel.setFont(new java.awt.Font("Dialog", 0, 12));
    panelBloques.setLayout(null);
    elegirColorFondo.setBounds(new Rectangle(8, 74, 433, 253));
    colorFondoLabel.setFont(new java.awt.Font("Dialog", 0, 12));
    colorFondoLabel.setText("Color de fondo");
    colorFondoLabel.setBounds(new Rectangle(8, 45, 98, 19));
    lookLabel.setFont(new java.awt.Font("Dialog", 0, 12));
    lookLabel.setText("Look and Feel");
    lookLabel.setVerticalTextPosition(SwingConstants.CENTER);
    lookLabel.setBounds(new Rectangle(8, 17, 136, 19));
    panelLookFeel.setLayout(null);
    comboLook.setBounds(new Rectangle(325, 15, 113, 24));
    cancelButton.setBounds(new Rectangle(349, 387, 108, 31));
    cancelButton.setFont(new java.awt.Font("Dialog", 0, 12));
    cancelButton.setText("Cancelar");
    cancelButton.addActionListener(this);
    acceptButton.setText("Aceptar");
    acceptButton.setBounds(new Rectangle(232, 387, 108, 31));
    acceptButton.setFont(new java.awt.Font("Dialog", 0, 12));
    acceptButton.setVerifyInputWhenFocusTarget(true);
    acceptButton.setSelected(false);
    acceptButton.addActionListener(new AcceptAction());
    this.setResizable(false);
    comboTamanioFuente.setBounds(new Rectangle(325, 15, 113, 24));
    comboAnchoLineas.setBounds(new Rectangle(325, 15, 113, 24));
    comboTamanioBloques.setBounds(new Rectangle(325, 15, 113, 24));
    panelVisualizacion.setLayout(null);
    jPanel1.setFont(new java.awt.Font("Dialog", 0, 12));
    jPanel1.setBorder(titledBorder2);
    jPanel1.setBounds(new Rectangle(25, 167, 178, 139));
    jPanel1.setLayout(null);
    botonLambda.setFont(new java.awt.Font("Dialog", 0, 12));
    botonLambda.setHorizontalAlignment(SwingConstants.LEFT);
    botonLambda.setHorizontalTextPosition(SwingConstants.RIGHT);
    botonLambda.setText("Tasa fallos");
    botonLambda.setVerticalAlignment(SwingConstants.CENTER);
    botonLambda.setBounds(new Rectangle(13, 27, 150, 25));
    botonMttf.setBounds(new Rectangle(13, 63, 149, 25));
    botonMttf.setText("MTTF");
    botonMttf.setHorizontalTextPosition(SwingConstants.RIGHT);
    botonMttf.setHorizontalAlignment(SwingConstants.LEFT);
    botonMttf.setFont(new java.awt.Font("Dialog", 0, 12));
    botonMttf.setVerticalAlignment(SwingConstants.CENTER);
    botonMtbf.setBounds(new Rectangle(13, 99, 151, 25));
    botonMtbf.setText("MTBF");
    botonMtbf.setHorizontalTextPosition(SwingConstants.RIGHT);
    botonMtbf.setHorizontalAlignment(SwingConstants.LEFT);
    botonMtbf.setFont(new java.awt.Font("Dialog", 0, 12));
    botonMtbf.setVerticalAlignment(SwingConstants.CENTER);
    botonMu.setBounds(new Rectangle(13, 27, 154, 25));
    botonMu.setVerticalAlignment(SwingConstants.CENTER);
    botonMu.setText("Tasa reparabilidad");
    botonMu.setHorizontalTextPosition(SwingConstants.RIGHT);
    botonMu.setHorizontalAlignment(SwingConstants.LEFT);
    botonMu.setFont(new java.awt.Font("Dialog", 0, 12));
    botonMu.setActionCommand("Mu");
    jPanel2.setLayout(null);
    jPanel2.setBounds(new Rectangle(228, 167, 178, 139));
    jPanel2.setFont(new java.awt.Font("Dialog", 0, 12));
    jPanel2.setBorder(titledBorder1);
    botonMttr.setBounds(new Rectangle(13, 63, 149, 25));
    botonMttr.setText("MTTR");
    botonMttr.setHorizontalTextPosition(SwingConstants.RIGHT);
    botonMttr.setHorizontalAlignment(SwingConstants.LEFT);
    botonMttr.setFont(new java.awt.Font("Dialog", 0, 12));
    botonMttr.setVerticalAlignment(SwingConstants.CENTER);
    jLabel5.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel5.setText("Nmero de decimales en pantalla");
    jLabel5.setBounds(new Rectangle(22, 30, 213, 26));
    campoDecimalesPantalla.setText("");
    campoDecimalesPantalla.setHorizontalAlignment(SwingConstants.RIGHT);
    campoDecimalesPantalla.setBounds(new Rectangle(305, 31, 101, 24));
    campoDecimalesResultado.setBounds(new Rectangle(305, 82, 101, 24));
    campoDecimalesResultado.setText("");
    campoDecimalesResultado.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel9.setBounds(new Rectangle(22, 81, 213, 26));
    jLabel9.setText("Nmero de decimales en resultado");
    jLabel9.setFont(new java.awt.Font("Dialog", 0, 12));
    panelFuente.add(elegirColorFuente, null);
    panelFuente.add(colorFuenteLabel, null);
    panelFuente.add(tamanioFuenteLabel, null);
    panelFuente.add(comboTamanioFuente, null);
    jTabbedPane1.add(panelLineas, "Lneas   ");
    jTabbedPane1.add(panelFuente, "Fuente  ");
    panelLineas.add(anchoLineasLabel, null);
    panelLineas.add(colorLineasLabel, null);
    panelLineas.add(elegirColorLineas, null);
    panelLineas.add(comboAnchoLineas, null);
    jTabbedPane1.add(panelBloques, "Bloques   ");
    panelBloques.add(elegirColorBloques, null);
    panelBloques.add(colorBloquesLabel, null);
    panelBloques.add(tamanioBloquesLabel, null);
    panelBloques.add(comboTamanioBloques, null);
    jTabbedPane1.add(panelLookFeel, "LookAndFeel ");
    panelLookFeel.add(lookLabel, null);
    panelLookFeel.add(colorFondoLabel, null);
    panelLookFeel.add(elegirColorFondo, null);
    panelLookFeel.add(comboLook, null);
    jTabbedPane1.add(panelVisualizacion, "Visualizacin");
    this.getContentPane().add(acceptButton, null);
    this.getContentPane().add(cancelButton, null);
    // Inserto los elementos de comboLooks, primero el actual.
    int k;
    for (k = 0; k < looks.length; k++) {
      if (looks[k].getName().compareTo(actualLook) == 0) {
        comboLook.addItem(looks[k].getName());
        break;
      }
    }
    // Luego el resto
    for (int i = 0; i < looks.length; i++) {
      if (i != k) {
        comboLook.addItem(looks[i].getName());
      }
    }

    // Inicializo los campos de los combo de tamaos de lnea y bloque

    String primero = "";
    for (int i = 0; i < tamanios.length; i++) {
      if (multiplicadores[i] == FramePrincipal.prefVars.obtenerMultiplicadorBloques()) {
        primero = tamanios[i];
      }
    }
    inicializarComboBox(comboTamanioBloques, tamanios, primero);

    for (int i = 0; i < tamanios.length; i++) {
      if (tamaniosReales[i] == FramePrincipal.prefVars.obtenerAnchoLineas()) {
        primero = tamanios[i];
      }
    }
    inicializarComboBox(comboAnchoLineas, tamanios, primero);

    for (int i = 0; i < tamanios.length; i++) {
      if (tamanioFuentes[i] == FramePrincipal.prefVars.obtenerTamanioFuente()) {
        primero = tamanios[i];
      }
    }
    inicializarComboBox(comboTamanioFuente, tamanios, primero);
    inicializarColores();
    inicializarVisualizacion();

    this.getContentPane().add(jTabbedPane1, null);
    jPanel1.add(botonMttf, null);
    jPanel1.add(botonLambda, null);
    jPanel1.add(botonMtbf, null);
    panelVisualizacion.add(jLabel5, null);
    panelVisualizacion.add(campoDecimalesPantalla, null);
    panelVisualizacion.add(jLabel9, null);
    panelVisualizacion.add(campoDecimalesResultado, null);
    panelVisualizacion.add(jPanel2, null);
    jPanel2.add(botonMu, null);
    jPanel2.add(botonMttr, null);
    panelVisualizacion.add(jPanel1, null);
    jTabbedPane1.setSelectedComponent(panelLineas);
    jPanel2.add(botonMu, null);

  }

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == cancelButton) {
      cancelar();
    }
  }

  private void inicializarColores() {
    elegirColorFondo.setColor(interfaz.FramePrincipal.prefVars.obtenerColorFondo());
    elegirColorLineas.setColor(interfaz.FramePrincipal.prefVars.obtenerColorLineas());
    elegirColorBloques.setColor(interfaz.FramePrincipal.prefVars.obtenerColorBloques());
    elegirColorFuente.setColor(interfaz.FramePrincipal.prefVars.obtenerColorFuente());
  }

  private void inicializarVisualizacion() {
    campoDecimalesResultado.setValue
        (new Integer(FramePrincipal.prefVars.obtenerNumeroDecimalesResultado()));
    campoDecimalesPantalla.setValue
        (new Integer(FramePrincipal.prefVars.obtenerNumeroDecimalesPantalla()));
    int valorMostrarFiabilidad =
        FramePrincipal.prefVars.obtenerValorMostrarFiabilidad();
    int valorMostrarReparabilidad =
        FramePrincipal.prefVars.obtenerValorMostrarReparabilidad();
    if (valorMostrarFiabilidad == 0) {
      botonLambda.setSelected(true);
    }
    else if (valorMostrarFiabilidad == 1) {
      botonMttf.setSelected(true);
    }
    else if (valorMostrarFiabilidad == 2) {
      botonMtbf.setSelected(true);
    }
    if (valorMostrarReparabilidad == 0) {
      botonMu.setSelected(true);
    }
    else if (valorMostrarReparabilidad == 1) {
      botonMttr.setSelected(true);
    }
  }

  public void nuevoLook(String landf) {
    try {
      UIManager.setLookAndFeel(landf);
      SwingUtilities.updateComponentTreeUI(framePadre);
    }
    catch (Exception e) {
      JOptionPane.showMessageDialog(null,
                                    "Se ha producido un error al cambiar el " +
                                    "look",
                                    "Error de look",
                                    JOptionPane.ERROR_MESSAGE);

    }
    interfaz.FramePrincipal.prefVars.asignarLook(landf);
  }

  private void actualizarLook(String look, String newLook) {
    // realizar la operacin si se ha cambiado el look
    if (look != newLook) {
      for (int i = 0; i < looks.length; i++) {
        if ( (looks[i].getName()) == newLook) {
          nuevoLook(looks[i].getClassName());
        }
      }
    }
  }

  private void actualizarAnchoLineas(float anchoLineas, int nuevoAnchoLineas) {
    // realizar la operacin si se ha cambiado el ancho
    if (anchoLineas != nuevoAnchoLineas) {
      interfaz.FramePrincipal.prefVars.asignarAnchoLineas(nuevoAnchoLineas);
    }
  }

  private void actualizarMultiplicadorBloques(double mult, double nuevomult) {
    // realizar la operacion si ha cambiado el multiplicador
    if (mult != nuevomult) {
      interfaz.FramePrincipal.prefVars.asignarMultiplicadorBloques(nuevomult);
    }
  }

  /** Actualiza el estado de la variable colorFondo de la variable estatica
   * prefVars de FramePrincipal, dndole como nuevo valor el color pasado como
   * parmetro*/
  private void actualizarColorFondo(Color colorFondo, Color nuevoColorFondo) {
    if (colorFondo != nuevoColorFondo) {
      interfaz.FramePrincipal.prefVars.asignarColorFondo(nuevoColorFondo);
    }
  }

  /** Actualiza el estado de la variable colorLineas de la variable estatica
   * prefVars de FramePrincipal, dndole como nuevo valor el color pasado como
   * parmetro*/
  private void actualizarColorLineas(Color colorLineas, Color nuevoColorLineas) {
    if (colorLineas != nuevoColorLineas) {
      interfaz.FramePrincipal.prefVars.asignarColorLineas(nuevoColorLineas);
    }
  }

  /** Actualiza el estado de la variable colorBloques de la variable estatica
   * prefVars de FramePrincipal, dndole como nuevo valor el color pasado como
   * parmetro*/
  private void actualizarColorBloques(Color colorBloques,
                                      Color nuevoColorBloques) {
    if (colorBloques != nuevoColorBloques) {
      interfaz.FramePrincipal.prefVars.asignarColorBloques(nuevoColorBloques);
    }
  }

  /** Actualiza el estado de la variable colorFuente de la variable estatica
   * prefVars de FramePrincipal, dndole como nuevo valor el color pasado como
   * parmetro*/
  private void actualizarColorFuente(Color colorFuente,
                                     Color nuevoColorFuente) {
    if (colorFuente != nuevoColorFuente) {
      interfaz.FramePrincipal.prefVars.asignarColorFuente(nuevoColorFuente);
    }
  }

  /** Actualiza el estado de las variables de visualizacin de la variable
   * estatica prefVars de FramePrincipal, dndole como nuevos valores los que
   * actualmente hay el la pantalla Visualizacin*/
  private void actualizarVisualizacion(int decimalesPantalla,
                                       int decimalesPNuevo,
                                       int decimalesResultado,
                                       int decimalesRNuevo,
                                       int valorMostradoFiabilidad,
                                       int valorMostrarFNuevo,
                                       int valorMostradoReparabilidad,
                                       int valorMostrarRNuevo) {
    if (decimalesPantalla != decimalesPNuevo) {
      FramePrincipal.prefVars.asignarNumeroDecimalesPantalla(decimalesPNuevo);
    }
    if (decimalesResultado != decimalesRNuevo) {
      FramePrincipal.prefVars.asignarNumeroDecimalesResultado(decimalesRNuevo);
    }
    if (valorMostradoFiabilidad != valorMostrarFNuevo) {
      FramePrincipal.prefVars.asignarValorMostrarFiabilidad(valorMostrarFNuevo);
    }
    if (valorMostradoReparabilidad != valorMostrarRNuevo) {
      FramePrincipal.prefVars.asignarValorMostrarReparabilidad(valorMostrarRNuevo);
    }
  }

  /** La funcin devolvera 1 si pequeo, 2 mediano, 4 grande. Siendo pequeo,
   * mediano y grande los posibles valores del combo.
   */
  private int obtenerValorEntero(JComboBox combo) {
    String tamanioLineas = (String) combo.getSelectedItem();

    int i;
    for (i = 0; i < tamanios.length; i++) {
      if (tamanios[i] == tamanioLineas) {
        break;
      }
    }
    return tamaniosReales[i];
  }

  private double obtenerMultiplicador(JComboBox combo) {
    String multiplicador = (String) combo.getSelectedItem();

    int i;
    for (i = 0; i < tamanios.length; i++) {
      if (tamanios[i] == multiplicador) {
        break;
      }
    }
    return multiplicadores[i];
  }

  private int obtenerTamanioFuente() {
    String tamanioFuen = (String) comboTamanioFuente.getSelectedItem();

    int i;
    for (i = 0; i < tamanios.length; i++) {
      if (tamanios[i] == tamanioFuen) {
        break;
      }
    }
    return tamanioFuentes[i];
  }

  private void actualizarTamanioFuente(int tamanioFuente,
                                       int nuevoTamanioFuente) {
    if (tamanioFuente != nuevoTamanioFuente) {
      FramePrincipal.prefVars.asignarTamanioFuente(nuevoTamanioFuente);
    }
  }

  /**Dada una lista de elementos y un elemento de la lista marcado como primero
   * Inicializa un ComboBox, el primero el dado y los demas por el orden que
   * tenan en el Array*/
  private void inicializarComboBox(JComboBox combo, Object[] elementos,
                                   String primeros) {
    // Inserto los elementos de comboLooks, primero el actual.
    int k;
    for (k = 0; k < elementos.length; k++) {
      if ( (elementos[k].toString()) == primeros) {
        combo.addItem(elementos[k]);
        break;
      }
    }
    // Luego el resto
    for (int i = 0; i < elementos.length; i++) {
      if (i != k) {
        combo.addItem(elementos[i].toString());
      }
    }

    this.getContentPane().add(cancelButton, null);
    this.getContentPane().add(acceptButton, null);
    panelBloques.add(comboTamanioBloques, null);
    jTabbedPane1.setSelectedComponent(panelLookFeel);
  }

  public int valorMostrarFiabilidad() {
    int valor = 3;
    if (botonLambda.isSelected()) {
      valor = 0;
    }
    else if (botonMttf.isSelected()) {
      valor = 1;
    }
    else if (botonMtbf.isSelected()) {
      valor = 2;
    }
    return valor;
  }

  public int valorMostrarReparabilidad() {
    int valor = 2;
    if (botonMu.isSelected()) {
      valor = 0;
    }
    else if (botonMttr.isSelected()) {
      valor = 1;
    }
    return valor;
  }

  class AcceptAction
      extends AbstractAction {
    public void actionPerformed(ActionEvent e) {
      String look = UIManager.getLookAndFeel().getName();
      String newLook = (String) comboLook.getSelectedItem();
      int anchoLineas = interfaz.FramePrincipal.prefVars.obtenerAnchoLineas();
      int nuevoAnchoLineas = obtenerValorEntero(comboAnchoLineas);
      String nuevotamanioLineas = (String) comboAnchoLineas.getSelectedItem();
      double multiplicadorBloques =
          interfaz.FramePrincipal.prefVars.obtenerMultiplicadorBloques();
      double nuevoMultiplicadorBloques = obtenerMultiplicador(
          comboTamanioBloques);
      int tamanioFuente =
          interfaz.FramePrincipal.prefVars.obtenerTamanioFuente();
      int nuevoTamanioFuente = obtenerTamanioFuente();
      Color colorFondo = interfaz.FramePrincipal.prefVars.obtenerColorFondo();
      Color nuevoColorFondo = elegirColorFondo.getColor();
      Color colorLineas = interfaz.FramePrincipal.prefVars.obtenerColorLineas();
      Color nuevoColorLineas = elegirColorLineas.getColor();
      Color colorBloques = interfaz.FramePrincipal.prefVars.obtenerColorBloques();
      Color nuevoColorBloques = elegirColorBloques.getColor();
      Color colorFuente = interfaz.FramePrincipal.prefVars.obtenerColorFuente();
      Color nuevoColorFuente = elegirColorFuente.getColor();
      int valorMostradoFiabilidad =
          FramePrincipal.prefVars.obtenerValorMostrarFiabilidad();
      int valorMostrarFNuevo = valorMostrarFiabilidad();
      int valorMostradoReparabilidad =
          FramePrincipal.prefVars.obtenerValorMostrarReparabilidad();
      int valorMostrarRNuevo = valorMostrarReparabilidad();
      int decimalesPantalla = FramePrincipal.prefVars.obtenerNumeroDecimalesPantalla();
      int decimalesPNuevo =
          ( (Number) campoDecimalesPantalla.getValue()).intValue();
      int decimalesRNuevo =
          ( (Number) campoDecimalesResultado.getValue()).intValue();
      int decimalesResultado = FramePrincipal.prefVars.obtenerNumeroDecimalesResultado();

      // Si hay algun cambio este podr deshacerse o rehacerse
      if ( (look != newLook) || (anchoLineas != nuevoAnchoLineas) ||
          (multiplicadorBloques != nuevoMultiplicadorBloques) || (colorFondo !=
          nuevoColorFondo) || (colorLineas != nuevoColorLineas) ||
          (colorBloques != nuevoColorBloques) ||
          (tamanioFuente != nuevoTamanioFuente) ||
          (colorFuente != nuevoColorFuente) ||
          (valorMostradoFiabilidad != valorMostrarFNuevo) ||
          (valorMostradoReparabilidad != valorMostrarRNuevo) ||
          (decimalesPantalla != decimalesPNuevo) ||
          (decimalesResultado != decimalesRNuevo))

      { // Graba el evento
        UndoableEdit edit = new PreferenciasAceptarEdit(framePadre,
            preferencias, newLook, look, nuevoAnchoLineas, anchoLineas,
            nuevoMultiplicadorBloques, multiplicadorBloques, nuevoColorFondo,
            colorFondo, nuevoColorLineas, colorLineas, nuevoColorBloques,
            colorBloques, nuevoColorFuente, colorFuente, nuevoTamanioFuente,
            tamanioFuente, decimalesPNuevo, decimalesPantalla,
            decimalesRNuevo, decimalesResultado, valorMostrarFNuevo,
            valorMostradoFiabilidad, valorMostradoReparabilidad,
            valorMostrarRNuevo);
        // Coloca el evento en el soporte de operaciones de deshacer/rehacer
        interfaz.FramePrincipal.undoSupport_.postEdit(edit);
      }
      actualizarLook(look, newLook);
      actualizarAnchoLineas(anchoLineas, nuevoAnchoLineas);
      actualizarMultiplicadorBloques(multiplicadorBloques,
                                     nuevoMultiplicadorBloques);
      actualizarColorFondo(colorFondo, nuevoColorFondo);
      actualizarColorLineas(colorLineas, nuevoColorLineas);
      actualizarColorBloques(colorBloques, nuevoColorBloques);
      actualizarColorFuente(colorFuente, nuevoColorFuente);
      actualizarTamanioFuente(tamanioFuente, nuevoTamanioFuente);
      actualizarVisualizacion(decimalesPantalla, decimalesPNuevo,
                              decimalesResultado, decimalesRNuevo,
                              valorMostradoFiabilidad, valorMostrarFNuevo,
                              valorMostradoReparabilidad, valorMostrarRNuevo);
      cancelar();
      // Actualiza el diagrama si este existe
      if (diagrama != null) {
        diagrama.repaint();
      }
    }
  }
}
