package interfaz.deshacer;

import javax.swing.undo.*;
import interfaz.Diagrama;
import bloques.Bloque;

/**
 * <p>Title: EditarPegarEdit</p>
 * <p>Description: Clase para la funcionalidad deshacer-rehacer de Pegar</p>
 * @author Diego Daz Garca
 * @version 1.0
 */

public class EditarPegarEdit
    extends AbstractUndoableEdit {
  Bloque bloqueAnt;
  Bloque bloqueNuevo;
  Bloque padre;
  int posicion;
  Diagrama diagrama;
  boolean copiaSobreNuevo;

  public EditarPegarEdit
      (Bloque bloqueAnt, Bloque bloqueNuevo, Diagrama diagrama,
       boolean copiaSobreNuevo, int posicion, Bloque padre) {
    this.bloqueAnt = bloqueAnt;
    this.bloqueNuevo = bloqueNuevo;
    this.padre = padre;
    this.diagrama = diagrama;
    this.copiaSobreNuevo = copiaSobreNuevo;
    this.posicion = posicion;
  }

  public void undo() throws CannotUndoException {
    padre.eliminaBloque(posicion);
    if (!copiaSobreNuevo) {
      padre.add(bloqueAnt, posicion);
    }
    diagrama.cambiarBloqueMostrado(padre);
  }

  public void redo() throws CannotUndoException {
    if (!copiaSobreNuevo) {
      padre.eliminaBloque(posicion);
    }
    padre.add(bloqueNuevo, posicion);
    diagrama.cambiarBloqueMostrado(padre);
  }

  public boolean canUndo() {
    return true;
  }

  public boolean canRedo() {
    return true;
  }

  public String getPresentationName() {
    return "Pegar";
  }
}
