package interfaz.deshacer;

import javax.swing.undo.*;
import bloques.*;
import interfaz.FiguraBloque;
import java.util.*;
import interfaz.Diagrama;

/**
 * <p>Title: ElementoBloqueExpansibleEdit</p>
 * <p>Description: Clase para la funcionalidad deshacer-rehacer de Aadir
 * bloque Expansible</p>
 * @author Diego Daz Garca
 * @version 1.0
 */

public class ElementoBloqueExpansibleEdit
    extends AbstractUndoableEdit {
  Bloque bloque;
  Bloque bloqueCreado;
  FiguraBloque figuraEliminada;
  Diagrama diagramaVisible;

  public ElementoBloqueExpansibleEdit(Bloque bloque_, Diagrama diagramaVisible) {
    bloque = bloque_;
    this.diagramaVisible = diagramaVisible;

  }

  public void undo() throws CannotUndoException {
    bloqueCreado = (Bloque) bloque.componentes.get(bloque.componentes.size() -
        1);
    bloque.eliminaBloque(bloque.componentes.size() - 1);
    diagramaVisible.cambiarBloqueMostrado(bloqueCreado.padre());
  }

  public void redo() throws CannotUndoException {
    bloque.add(bloqueCreado, bloque.componentes.size());
    diagramaVisible.cambiarBloqueMostrado(bloqueCreado.padre());
  }

  public boolean canUndo() {
    return true;
  }

  public boolean canRedo() {
    return true;
  }

  public String getPresentationName() {
    return "Aadir bloque expansible";
  }
}
