package interfaz.deshacer;

import javax.swing.undo.*;
import bloques.*;
import interfaz.Diagrama;
import interfaz.*;

/**
 * <p>Title: ElementoCambiarNombreEdit</p>
 * <p>Description: Clase para la funcionalidad deshacer-rehacer de Cambiar
 * nombre bloque</p>
 * @author Diego Daz Garca
 * @version 1.0
 */

public class ElementoCambiarNombreEdit
    extends AbstractUndoableEdit {
  Bloque bloque;
  String antiguoNombre;
  String nuevoNombre;

  // La clase tiene que tener uno de estos dos elementos distinto de null
  // para actualizar la ventana de opciones. Dependiendo del constructor
  // empleado ser null diagramaVisible o ventanaPrincipal
  Diagrama diagramaVisible = null;
  FramePrincipal ventanaPrincipal = null;

  public ElementoCambiarNombreEdit(Diagrama diagrama, Bloque bloque_,
                                   String antiguoNombre_, String nuevoNombre_) {
    bloque = bloque_;
    antiguoNombre = antiguoNombre_;
    nuevoNombre = nuevoNombre_;
    diagramaVisible = diagrama;
  }

  public ElementoCambiarNombreEdit(FramePrincipal ventanaPrincipal_,
                                   Bloque bloque_,
                                   String antiguoNombre_, String nuevoNombre_) {
    bloque = bloque_;
    antiguoNombre = antiguoNombre_;
    nuevoNombre = nuevoNombre_;
    ventanaPrincipal = ventanaPrincipal_;
  }

  public void undo() throws CannotUndoException {
    bloque.cambiarNombre(antiguoNombre);
    if (diagramaVisible != null)
      diagramaVisible.gestionarCambioNombre(nuevoNombre, antiguoNombre);
    else
      ventanaPrincipal.gestionarCambioNombre(nuevoNombre, antiguoNombre);
  }

  public void redo() throws CannotUndoException {
    bloque.cambiarNombre(nuevoNombre);
    if (diagramaVisible != null)
      diagramaVisible.gestionarCambioNombre(antiguoNombre, nuevoNombre);
    else
      ventanaPrincipal.gestionarCambioNombre(antiguoNombre, nuevoNombre);
  }

  public boolean canUndo() {
    return true;
  }

  public boolean canRedo() {
    return true;
  }

  public String getPresentationName() {
    return "Cambiar Nombre";
  }
}
