package interfaz.deshacer;

import javax.swing.undo.*;
import bloques.*;
import java.util.*;
import interfaz.Opciones;

/**
 * <p>Title: ResolverOpcionesEdit.java</p>
 * <p>Description: Clase para la funcionalidad deshacer-rehacer de los cambios
 * en las opciones de resolucin</p>
 * @author Diego Daz Garca
 * @version 1.0
 */

public class ResolverOpcionesEdit
    extends AbstractUndoableEdit {
  /**referenciar al Opciones con los valores anteriores de las opciones*/
  Opciones opcionesAnterior;
  /**Nuevo opciones en el que copiaremos el estado actual de
   * opcionesResolucion*/
  Opciones opcionesNuevas;
  /**Opciones en el que copiaremos la referencia al opcionesResolucion*/
  Opciones referenciaOpciones;

  public ResolverOpcionesEdit(Opciones anterior, Opciones nuevas, Bloque bloque) {
    opcionesAnterior = anterior;
    opcionesNuevas = new Opciones(null, bloque);
    opcionesNuevas.copiarEstado(nuevas);
    referenciaOpciones = nuevas;
  }

  public void undo() throws CannotUndoException {
    referenciaOpciones.copiarEstado(opcionesAnterior);
  }

  public void redo() throws CannotUndoException {
    referenciaOpciones.copiarEstado(opcionesNuevas);
  }

  public boolean canUndo() {
    return true;
  }

  public boolean canRedo() {
    return true;
  }

  public String getPresentationName() {
    return "Cambiar opciones";
  }
}
